# openapi-client

No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 1.0.0
- Package version: 1.0.0
- Build package: org.openapitools.codegen.languages.PythonClientCodegen

## Requirements.

Python 2.7 and 3.4+

## Installation & Usage

### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```

(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:

```python
import openapi_client
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```

(or `sudo python setup.py install` to install the package for all users)

Then import the package:

```python
import openapi_client
```

## Virtual Environment

You can create a new virtual environment by running:

```bash
python -m venv .venv
```

Then activate it:

```bash
source .venv/bin/activate   # macOS/Linux
.venv\Scripts\activate      # Windows
```

Finally, install dependencies:

```bash
pip install -r requirements.txt
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python
from __future__ import print_function

import time
import openapi_client
from openapi_client.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to http://localhost
# See configuration.py for a list of all supported configuration parameters.
configuration = openapi_client.Configuration(
    host = "http://localhost"
)

# The client must configure the authentication and authorization parameters
# in accordance with the API server security policy.
# Examples for each auth method are provided below, use the example that
# satisfies your auth use case.

# Configure Bearer authorization: bearer
configuration = openapi_client.Configuration(
    access_token = 'YOUR_BEARER_TOKEN'
)


# Enter a context with an instance of the API client
with openapi_client.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = openapi_client.OpenAPIApi(api_client)
    apikey = 'apikey_example' # str | apikey
page = 1 # int | Page number (optional) (default to 1)
limit = 10 # int | Number of items per page (optional) (default to 10)
authorization = 'eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJ1c2VyX2lkIjoyLCJ3YWxsZXRfYWRkcmVzcyI6IjB4ZDYzYWU0Yzg2MDIwMzhmMTU5NTM1NTcxYjIzZjlhOGU5OGQxYzI4OSIsIndhbGxldF91c2VyIjoiIiwiaXNzIjoicHJlZGljdGlvbl9tYXJrZXQiLCJleHAiOjE3NDM1MDAzNDEsImlhdCI6MTcyNTM1NjM0MX0.L2IIQJwCoYK1Cf_id2fAWHgzvDaWpXiFQO-ipGPT3fE' # str |  (optional) (default to 'eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJ1c2VyX2lkIjoyLCJ3YWxsZXRfYWRkcmVzcyI6IjB4ZDYzYWU0Yzg2MDIwMzhmMTU5NTM1NTcxYjIzZjlhOGU5OGQxYzI4OSIsIndhbGxldF91c2VyIjoiIiwiaXNzIjoicHJlZGljdGlvbl9tYXJrZXQiLCJleHAiOjE3NDM1MDAzNDEsImlhdCI6MTcyNTM1NjM0MX0.L2IIQJwCoYK1Cf_id2fAWHgzvDaWpXiFQO-ipGPT3fE')

    try:
        # Get currency list
        api_response = api_instance.openapi_currency_get(apikey, page=page, limit=limit, authorization=authorization)
        pprint(api_response)
    except ApiException as e:
        print("Exception when calling OpenAPIApi->openapi_currency_get: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to _http://localhost_

| Class          | Method                                                                                                      | HTTP request                                  | Description                                   |
| -------------- | ----------------------------------------------------------------------------------------------------------- | --------------------------------------------- | --------------------------------------------- |
| _OpenAPIApi_   | [**openapi_currency_get**](docs/OpenAPIApi.md#openapi_currency_get)                                         | **GET** /openapi/currency                     | Get currency list                             |
| _OpenAPIApi_   | [**openapi_order_cancel_order_post**](docs/OpenAPIApi.md#openapi_order_cancel_order_post)                   | **POST** /openapi/order/cancel/order          | Cancel an order                               |
| _OpenAPIApi_   | [**openapi_order_get**](docs/OpenAPIApi.md#openapi_order_get)                                               | **GET** /openapi/order                        | Get orders                                    |
| _OpenAPIApi_   | [**openapi_order_kline_get**](docs/OpenAPIApi.md#openapi_order_kline_get)                                   | **GET** /openapi/order/kline                  | Get kline data of a market                    |
| _OpenAPIApi_   | [**openapi_order_market_depth_get**](docs/OpenAPIApi.md#openapi_order_market_depth_get)                     | **GET** /openapi/order/market/depth           | Get orderbook depth of a market               |
| _OpenAPIApi_   | [**openapi_order_orderbook_get**](docs/OpenAPIApi.md#openapi_order_orderbook_get)                           | **GET** /openapi/order/orderbook              | Get orderbook of a market                     |
| _OpenAPIApi_   | [**openapi_order_post**](docs/OpenAPIApi.md#openapi_order_post)                                             | **POST** /openapi/order                       | Create an order                               |
| _OpenAPIApi_   | [**openapi_portfolio_get**](docs/OpenAPIApi.md#openapi_portfolio_get)                                       | **GET** /openapi/portfolio                    | Get portfolio data of user                    |
| _OpenAPIApi_   | [**openapi_topic_get**](docs/OpenAPIApi.md#openapi_topic_get)                                               | **GET** /openapi/topic                        | Get Topic List                                |
| _OpenAPIApi_   | [**openapi_topic_multi_topic_id_get**](docs/OpenAPIApi.md#openapi_topic_multi_topic_id_get)                 | **GET** /openapi/topic/multi/{topicId}        | Get Detail of a Categorical Topic             |
| _OpenAPIApi_   | [**openapi_topic_topic_id_get**](docs/OpenAPIApi.md#openapi_topic_topic_id_get)                             | **GET** /openapi/topic/{topicId}              | Get Detail of a Binary Topic                  |
| _OpenAPIApi_   | [**openapi_trade_get**](docs/OpenAPIApi.md#openapi_trade_get)                                               | **GET** /openapi/trade                        | Get user&#39;s trades                         |
| _OpenAPIApi_   | [**openapi_user_wallet_address_balance_get**](docs/OpenAPIApi.md#openapi_user_wallet_address_balance_get)   | **GET** /openapi/user/{walletAddress}/balance | Get ERC20 Balances of a user (apikey account) |
| _V2OpenAPIApi_ | [**openapi_currency_get**](docs/V2OpenAPIApi.md#openapi_currency_get)                                       | **GET** /openapi/currency                     | Get currency list                             |
| _V2OpenAPIApi_ | [**openapi_order_cancel_order_post**](docs/V2OpenAPIApi.md#openapi_order_cancel_order_post)                 | **POST** /openapi/order/cancel/order          | Cancel an order                               |
| _V2OpenAPIApi_ | [**openapi_order_get**](docs/V2OpenAPIApi.md#openapi_order_get)                                             | **GET** /openapi/order                        | Get orders                                    |
| _V2OpenAPIApi_ | [**openapi_order_kline_get**](docs/V2OpenAPIApi.md#openapi_order_kline_get)                                 | **GET** /openapi/order/kline                  | Get kline data of a market                    |
| _V2OpenAPIApi_ | [**openapi_order_market_depth_get**](docs/V2OpenAPIApi.md#openapi_order_market_depth_get)                   | **GET** /openapi/order/market/depth           | Get orderbook depth of a market               |
| _V2OpenAPIApi_ | [**openapi_order_orderbook_get**](docs/V2OpenAPIApi.md#openapi_order_orderbook_get)                         | **GET** /openapi/order/orderbook              | Get orderbook of a market                     |
| _V2OpenAPIApi_ | [**openapi_order_post**](docs/V2OpenAPIApi.md#openapi_order_post)                                           | **POST** /openapi/order                       | Create an order                               |
| _V2OpenAPIApi_ | [**openapi_portfolio_get**](docs/V2OpenAPIApi.md#openapi_portfolio_get)                                     | **GET** /openapi/portfolio                    | Get portfolio data of user                    |
| _V2OpenAPIApi_ | [**openapi_topic_get**](docs/V2OpenAPIApi.md#openapi_topic_get)                                             | **GET** /openapi/topic                        | Get Topic List                                |
| _V2OpenAPIApi_ | [**openapi_topic_multi_topic_id_get**](docs/V2OpenAPIApi.md#openapi_topic_multi_topic_id_get)               | **GET** /openapi/topic/multi/{topicId}        | Get Detail of a Categorical Topic             |
| _V2OpenAPIApi_ | [**openapi_topic_topic_id_get**](docs/V2OpenAPIApi.md#openapi_topic_topic_id_get)                           | **GET** /openapi/topic/{topicId}              | Get Detail of a Binary Topic                  |
| _V2OpenAPIApi_ | [**openapi_trade_get**](docs/V2OpenAPIApi.md#openapi_trade_get)                                             | **GET** /openapi/trade                        | Get user&#39;s trades                         |
| _V2OpenAPIApi_ | [**openapi_user_wallet_address_balance_get**](docs/V2OpenAPIApi.md#openapi_user_wallet_address_balance_get) | **GET** /openapi/user/{walletAddress}/balance | Get ERC20 Balances of a user (apikey account) |

## Documentation For Models

- [ModelsTopicStatus](docs/ModelsTopicStatus.md)
- [V2AddOrderReq](docs/V2AddOrderReq.md)
- [V2AddOrderResp](docs/V2AddOrderResp.md)
- [V2ChildTopicData](docs/V2ChildTopicData.md)
- [V2GetBalanceResp](docs/V2GetBalanceResp.md)
- [V2OrderData](docs/V2OrderData.md)
- [V2OrderListResp](docs/V2OrderListResp.md)
- [V2PortfolioData](docs/V2PortfolioData.md)
- [V2PortfolioResp](docs/V2PortfolioResp.md)
- [V2TopicData](docs/V2TopicData.md)
- [V2TopicDetailResp](docs/V2TopicDetailResp.md)
- [V2TopicListResp](docs/V2TopicListResp.md)
- [V2TradeData](docs/V2TradeData.md)
- [V2TradeListResp](docs/V2TradeListResp.md)
- [ViewApiBaseResponse](docs/ViewApiBaseResponse.md)
- [ViewCancelOrderResp](docs/ViewCancelOrderResp.md)
- [ViewCurrencyData](docs/ViewCurrencyData.md)
- [ViewCurrencyListResp](docs/ViewCurrencyListResp.md)
- [ViewKlineData](docs/ViewKlineData.md)
- [ViewKlineResp](docs/ViewKlineResp.md)
- [ViewMarketDepthResp](docs/ViewMarketDepthResp.md)
- [ViewMarketOrderBookResp](docs/ViewMarketOrderBookResp.md)

## Documentation For Authorization

## bearer

- **Type**: Bearer authentication

## Author
